#ifndef COMMON_H
#define COMMON_H
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <glib.h>
#include <gnome.h>
#include <syslog.h>
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include "ipmsg.h"
#include "udp.h"
#include "message.h"
#include "userdb.h"
#include "hostinfo.h"
#include "msginfo.h"
#include "logfile.h"
#include "menu.h"
#include "fileattach.h"
#include "tcp.h"
#include "netcommon.h"
#include "fuzai.h"
#include "copying.h"
#include "uicommon.h"
#include "sound.h"
#include "systray.h"
#include "downloads.h"
#include "codeset.h"
#include "protocol.h"
#include "msgout.h"
#include "private.h"
#include "compat.h"

extern udp_con_t *udp_con;
#define IPMSG_COMMON_MAX_RETRY (20)
#define MSG_WATCH_INTERVAL (500)
#define IPMG_LOCK_FILE "/tmp/g2ipmsg.lock"
#define IPMSG_KEY_BTN_CHATTER_MS (300)
#define USERLIST_PRIO_MIN        (-1)
#define USERLIST_DEFAULT_PRIO    (0)
#define USERLIST_PRIO_MAX        (4)

#define prio_is_valid(prio_val)  ( (prio_val>=USERLIST_PRIO_MIN) && \
				   (prio_val<=USERLIST_PRIO_MAX) )


#define IPMSG_BUFSIZ 0x1000
#define _MSG_BUF_SIZE 65536
#define _MSG_BUF_MIN_SIZE ((_MSG_BUF_SIZE)/2)
#define G2IPMSG_DEFAULT_ENTRY_FLAGS (IPMSG_FILEATTACHOPT)
#define G2IPMSG_DEFAULT_HOST_LIST_LEN 1

int init_ipmsg(void);
void cleanup_ipmsg(void);
int create_lock_file(void);
int release_lock_file(void);

#endif
