#if !defined(DOWNLOADS_H)
#define DOWNLOADS_H
#include <glib.h>
#include <gnome.h>

typedef struct _dir_request{
  long header_size;
  gchar *filename;
  size_t file_size;
  unsigned long ipmsg_fattr;
}dir_request_t;
#define download_base_cmd(attr) ((attr)&(0xff))
#define DOWNLOAD_FILEID_NUM     0
#define DOWNLOAD_FILENAME_NUM   1
#define DOWNLOAD_RECVSIZE_NUM   2
#define DOWNLOAD_FILESIZE_NUM   3
#define DOWNLOAD_PROGRESS_NUM   4
#define DOWNLOAD_FILEATTR_NUM   5
#define DOWNLOAD_FILETYPE_NUM   6

int internal_create_download_window(GtkWidget *recvWin,GtkWidget **window);
int download_dir_open_operation(const char *dir);
int download_file_ok_operation(const char *file,const char *filepath,size_t size,const char *dir);
int download_file_failed_operation(const char *filepath,const char *basename);
int post_download_operation(int code,const char *filepath,size_t size,size_t all_size,const char *dir,gboolean exec);
int do_download_regular_file(tcp_con_t *con, const char *filepath,size_t file_size,size_t *written,GtkTreeModel *model,GtkTreeIter *iter);
int send_download_request(tcp_con_t *con, unsigned long ftype,long pkt_no,int fileid);
int do_download_directory(tcp_con_t *con, const char *top_dir,GtkTreeModel *model,GtkTreeIter *iter);
gboolean is_supported_file_type(unsigned long ipmsg_fattr);
void recv_attachments(gpointer data);
#endif 
