#if !defined(PRIVATE_H)
#define PRIVATE_H
#define IPMSG_PRIVATE_DATA_MAGIC 0x19731219
#define IPMSG_PRIVATE_NO_TYPE 0
#define IPMSG_PRIVATE_RECVMSG 1
#define IPMSG_PRIVATE_AFCB    2
typedef struct _ipmsg_private_data{
  int magic;
  int type;
  void *data;
}ipmsg_private_data_t;

typedef struct _ipmsg_recvmsg_private{
  char *ipaddr;
  int   pktno;
  int   flags;
  char *ext_part;
}ipmsg_recvmsg_private_t;

#define IPMSG_ASSERT_PRIVATE(private,ptype) do{			 \
    g_assert((private));					 \
    g_assert((private)->magic == IPMSG_PRIVATE_DATA_MAGIC);	 \
    g_assert((private)->type == (ptype));			 \
  }while(0)

#define IPMSG_HOOKUP_DATA(component,data_p,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    data_p, (GDestroyNotify) destroy_ipmsg_private)

int init_ipmsg_private(ipmsg_private_data_t **priv,const int type);
int init_recvmsg_private(const char *ipaddr,int flags,int pktno, ipmsg_private_data_t **priv);
void destroy_ipmsg_private(gpointer data);

#endif
