#if !defined(IPMSG_TCP_H)
#include <signal.h>
#define IPMSG_TCP_H
#define TCP_LISTEN_LEN 5
#define TCP_DOWNLOAD_RETRY 200
#define TCP_FLUSH_RETRY    10
#define TCP_SELECT_SEC 1
#define TCP_CLIENT_TMOUT_MS  500
#define TCP_CLOSE_WAIT_SEC 5
#define TCP_FILE_BUFSIZ 4096
typedef struct _tcp_con{
  int soc;
  int family;
  struct addrinfo *self;
}tcp_con_t;
typedef struct _request_msg{
  long pkt_no;
  int fileid;
  int offset;
}request_msg_t;
typedef struct _tcp_dsend_pkt{
  tcp_con_t *con;
  char *topdir;
}tcp_dsend_pkt_t;

gpointer ipmsg_tcp_server_thread(gpointer data);
int tcp_enable_keepalive(const tcp_con_t *con);
int tcp_setup_client(int family,const char *ipaddr,int port,tcp_con_t *con);
int tcp_flush_buffer(tcp_con_t *con);
int tcp_set_ipmsg_bufsiz(int soc);
int disable_pipe_signal(struct sigaction *saved_act);
int enable_pipe_signal(struct sigaction *saved_act);
#endif /* IPMSG_TCP_H */
